package com.zt.controller;

import com.zt.common.pojo.CeShi;
import jakarta.validation.Valid;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;
import com.zt.common.utils.SingUtil;

/**
 * @Date 2025/3/31 15:27
 * @Author neko
 **/
@RestController
@RequestMapping("/api")
public class ApiController {
    @PostMapping("/interface1")
    public ResponseEntity<String> interface1(@RequestHeader("reqId") String reqId, @Valid @RequestBody CeShi params) {
        if (!SingUtil.verifySign(params.getAppId(), params.getGoodsId(), reqId, params.getReqTime(), params.getSign())) {
            return new ResponseEntity<>("签名验证失败", HttpStatus.BAD_REQUEST);
        }
        return new ResponseEntity<>("接口一处理成功", HttpStatus.OK);
    }

    @GetMapping("/interface2")
    public ResponseEntity<String> interface2(@RequestHeader("reqId") String reqId,
                                             @RequestParam("appId") String appId,
                                             @RequestParam("sign") String sign,
                                             @RequestParam("reqTime") String reqTime,
                                             @RequestParam("goodsId") String goodsId,
                                             @RequestParam("amount") Integer amount,
                                             @RequestParam("price") Double price,
                                             @RequestParam("mobile") String mobile,
                                             @RequestParam("nowDate") String nowDate) {
        CeShi params = new CeShi();
        params.setAppId(appId);
        params.setSign(sign);
        params.setReqTime(reqTime);
        params.setGoodsId(goodsId);
        params.setAmount(amount);
        params.setPrice(price);
        params.setMobile(mobile);
        params.setNowDate(nowDate);

        if (!SingUtil.verifySign(appId, goodsId, reqId, reqTime, sign)) {
            return new ResponseEntity<>("签名验证失败", HttpStatus.BAD_REQUEST);
        }
        return new ResponseEntity<>("接口二处理成功", HttpStatus.OK);
    }
}
